package dev.pfaff.altargui.element;

import dev.pfaff.altargui.StencilLayoutContext;
import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import org.jetbrains.annotations.MustBeInvokedByOverriders;

public abstract class SingleChildWidgetInstance<W extends Widget> extends CustomLayoutSingleChildWidgetInstance<W> {
	protected SingleChildWidgetInstance(WidgetInstantiationArgs args) {
		super(args);
	}

	@Override
	@MustBeInvokedByOverriders
	protected void computeStencilLayout(StencilLayoutContext context) {
		context.layout(this, getChildElement(), (e, ctx) -> {
			e.copyAvailableSizeFrom(this);
			e.stencilLayout(ctx);
			copyComputedSizeFrom(e);
		});
	}

	@Override
	@MustBeInvokedByOverriders
	protected void computeTraceLayout() {
		var e = getChildElement();
		e.copyPositionFrom(this);
		e.traceLayout();
	}
}
